<!DOCTYPE html>
<html>

<head lang="es">
	<meta charset="utf-8">
	<title>Trabajo en grupo TG3</title>
	<link rel="stylesheet" href="style.css">
	<style>
		table,
		th,
		td {
			border: 1px solid black;
		}
	</style>
</head>

<body>
	<header>
		<h1>Desarrollo con Tecnologias Emergentes. Curso 2019-20<br>
			Trabajo TG3 del grupo T7<br>
			Titulo: TG3. Implementar dos tecnologias emergentes</h1>
	</header>
	<nav>
		<ul>
			<li><a href="#1">1. Informacion general</a></li>
			<li><a href="#2">2. Requisitos de los prototipos a implementar</a></li>
			<li><a href="#3">3. Criterios de comparacion de los prototipos</a></li>
			<li><a href="#4">4. Implementación del prototipo con tecnología A</a></li>
			<li><a href="#5">5. Implementación del prototipo con tecnología B</a></li>
			<li><a href="#6">6. Comparacion de los prototipos</a></li>
			<li><a href="#7">7. Conclusiones</a></li>
		</ul>
	</nav>

	<main>
		<section id=1">
			<h2>1. Informacion general</h2>
			<h3>1.1 Autores</h3>
	    	<p>T7</p>
			<p>Javier Hernández Ortiz</p>
			<p>Javier Velilla Martinez</p>
			<p>Raul Benito Rodriguez</p>
			<p>Javier Palanques de Maria</p>
			<p>David Fuentes Miguel</p>
			
			<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
            <a href="https://gitlab.com/dte2020/t7/tg3">Enlace al repositorio de GitLab</a>
			<h3>1.3 Burndown chart</h3>
			<p>En este apartado se debe incrustar la imagen Burndown final TG3.</p>
			<img src="burndownTG3.PNG">
			<h3>1.4 Presentacion del trabajo</h3>
			<p>En este apartado se debe incluir el enlace al archivo de la presentacion con diapositivas, ubicado en el
				repositorio del proyecto.</p>
			<a href="tg3.pptx">Presentacion con diapositivas del trabajo TG3</a></p>
		</section>
		<section id="2">
			<h2>2. Requisitos de los prototipos a implementar</h2>
			<h3>2.1 Catálogo de requisitos</h3>
			<table>
				<tr>
					<th>Req.</th>
					<th>Descripcion</th>
				</tr>
				<tr>
					<td>01</td>
					<td>El lenguaje de programación a utilizar será, obligatoriamente, Java</td>
				</tr>
				<tr>
					<td>02</td>
					<td>El código del programa debe haber sido desarrollado en Net Beans</td>
				</tr>
				<tr>
					<td>03</td>
					<td>Todos los métodos de las clases implementadas se deben haber testeado previamente en JUnit</td>
				</tr>
				<tr>
					<td>04</td>
					<td>El programa debe poder realizar una operación básica que sume dos números naturales.</td>
				</tr>
				<tr>
				    <td>05</td>
					<td>El programa debe poder realizar una operación básica que, dados dos naturales, le reste el segundo al primero.</td>
				</tr>
				<tr>
				    <td>06</td>
					<td>El programa debe poder realizar una operación de conversión de metros a millas</td>
				</tr>
				<tr>
				    <td>07</td>
					<td>El programa debe poder realizar una operación de conversión de metros a pulgadas</td>
				</tr>
				<tr>
				    <td>08</td>
					<td>El programa debe poder realizar una operación de conversión de metros a pies</td>
				</tr>
				<tr>
				    <td>09</td>
					<td>El programa debe poder recibir una frase y convertir la primera letra de cada palabra a su equivalente en mayúsculas</td>
				</tr>
			</table>
		</section>
		<section id="3">
			<h2>3. Criterios de comparacion de los prototipos</h2>
	
			<h3>3.1 Criterio 1: Horas empleadas</h3>
			
			<ul>
				<li>Nombre del criterio: Horas empleadas.</li>
				<li>Descripcion: Horas invertidas en el desarrollo e implementación de los prototipos.</li>
				<li>Tipo de valor: Numérico (horas).</li>
			</ul>
			<h3>3.2 Criterio 2: Facilidad de implementación</h4>
				<ul>
					<li>Nombre del criterio: Facilidad de implementación</li>
					<li>Descripcion: Porcentaje de dificultad de la implantación de los prototipos</li>
					<li>Tipo de valor: Numérico (%)</li>
				</ul>
				
            <h3>3.3 Criterio 3: Recursos disponibles</h4>
				<ul>
					<li>Nombre del criterio: Recuros disponibles</li>
					<li>Descripcion: Recursos como documentación, vídeos o cursos que puedan facilitar el entendimiento del sistme para poder crear los prototipos</li>
					<li>Tipo de valor: Texto</li>
				</ul>
				
			<h3>3.4 Criterio 4: Formación</h4>
				<ul>
					<li>Nombre del criterio: Formación </li>
					<li>Descripcion: ¿Para cuál de las herramientas se ha necesitado una mayor formación?</li>
					<li>Tipo de valor: Texto.</li>
				</ul>
			<h3>3.5 Criterio 5: Problemas no resueltos</h4>
				<ul>
					<li>Nombre del criterio: Problemas no resueltos</li>
					<li>Descripcion: Comentar los problemas no resueltos</li>
					<li>Tipo de valor: Texto</li>
				</ul>
		</section>

		<section id="4">
			<h2>4. Implementación del prototipo con tecnología A: GitLab CI</h2>
			<p>
				<a
					href="https://gitlab.com/dte2020/t7/tg3/-/tree/master/prototipo-A/">https://gitlab.com/dte2020/t7/tg3/-/tree/master/prototipo-A/</a>.
			</p>
			<p>En esta carpeta se encuentran los archivos del programa Java. En la carpeta main podemos encontrar las clases principales,
			y en la carpeta test tenemos las clases de test de JUnit creadas en Java.</p>
			
			<p>Hemos modificado los .gitlab-ci.yml para que se ejecuten las pruebas de JUnit.
			Hemos renombrado este archivo después de subir los archivos Java y que se testearan sin problema, porque sino no podíamos desplegar
			el html como en las prácticas anteriores.</p>
		</section>

		<section id="5">
			<h2>5. Implementación del prototipo con tecnología B: Circle CI</h2>
			<p>
				<a
					href="https://gitlab.com/dte2020/t7/tg3/-/tree/master/prototipo-B/">https://gitlab.com/dte2020/t7/tg3/-/tree/master/prototipo-B/</a>.
			</p>
			<p>No hemos conseguido implementar la compatibilidad de Circle CI con Github. Nos parece una herramienta muy difícil de implementar
			sin ningún tipo de ayuda externa ni formación. Adjuntamos en la carpeta del prototipo B algunas capturas de nuestros intentos.</p>
			
		</section>

		<section id="6">
			<h2>6. Comparacion de los prototipos</h2>
			<p>Debe incluir al menos una tabla resumen cruzando los criterios y los
				valores de cada tecnología. Con una columna de comentarios sobre la comparación.</p>
			<table>
				<tr>
					<th>Criterio</th>
					<th>Prototipo A: GitLab CI</th>
					<th>Prototipo B: Circle CI</th>
					<th>Comentarios</th>

				</tr>
				<tr>
					<td>Horas empleadas</td>
					<td>3</td>
					<td>4</td>
					<td>Respecto a implementación invertimos un tiempo mayor en la plataforma Circle CI. Suponía conocer aspectos que no habíamos tratado antes y llevaba un mayor tiempo en realizar</td>
				</tr>
				<tr>
					<td>Facilidad de implementación</td>
					<td>80%</td>
					<td>20%</td>
					<td>Al implementar las tecnologías respecto a tiempo en realizar la tarea e introducir la información necesaria en GitLab CI fue bastante más complejo con Circle CI</td>
				</tr>
				<tr>
					<td>Recursos disponibles</td>
					<td> </td>
					<td> </td>
					<td>Respecto a documentación externa nos ha parecido más comprensible e intuitiva lo encontrado sobre GitLab CI comparada con la ambigüedad que se plantea en lo visto con documentación de Circle CI. </td>
				</tr>
				<tr>
					<td>Formación</td>
					<td>Menor formación para implementación</td>
					<td>Mayor formacón para la implementación</td>
					<td>Conlleva una mayor formación la tecnología Circle CI</td>
				</tr>
				<tr>
					<td>Problemas no resueltos</td>
					<td> </td>
					<td> </td>
					<td>El principal problema encontrado a la hora de implementación ha surgido con la tecnología Circle CI, puesto que su implementación nos ha dado errores y no se ha podido realizar completamente </td>
				</tr>
			</table>
		</section>

		<section id="7">
			<h2>7. Conclusiones</h2>
			<p>A partir de la información incluida en el apartado 7 y de la experiencia al realizar el trabajo, el grupo
				debe estar en condiciones de manifestar su opinión sobre la implementación de dos prototipos similares
				pero usando dos tecnologías diferentes.
				Hay que indicar las ventajas e inconvenientes más relevantes
				de utilizar una u otra tecnología para implementar el prototipo.</p>
		</section>

	</main>

</body>

</html>
